<script>
import { GlSearchBoxByType, GlButton, GlLabel, GlFormSelect } from '@gitlab/ui'
import LocalStorage from '@/mixins/local-storage'
import { getSearchQuery, setSearchQuery } from '@/assets/get-search-query'

export default {
  name: 'MdTableConfig',

  components: { GlSearchBoxByType, GlButton, GlLabel, GlFormSelect },

  mixins: [LocalStorage],

  props: {
    columns: {
      type: Array,
      required: true,
    },

    paginationLimit: {
      type: Number,
      required: true,
    },

    exportPath: {
      type: String,
      required: true,
    },

    sharePath: {
      type: String,
      required: false,
      default: '',
    },

    namespace: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      searchValue: '',
      showSettings: false,
      paginationOptions: [10, 15, 20, 50, 100].map((limit) => ({
        value: limit,
        text: limit,
      })),
    }
  },

  computed: {
    configurableColumns() {
      return this.columns.filter((column) => !column.nonConfigurable)
    },
  },

  mounted() {
    this.setInitialSearchValue()
  },

  methods: {
    search(term) {
      this.$emit('search', term)
      setSearchQuery(term)
    },

    toggleSettings() {
      this.showSettings = !this.showSettings
    },

    toggleColumn(id, forceShow = false) {
      const index = this.columns.findIndex((column) => column.id === id)

      if (index > -1) {
        if (forceShow && !this.columns[index].hidden) {
          return
        }

        const columns = [...this.columns]
        columns[index].hidden = !columns[index].hidden
        this.$emit('columns-change', columns)
        this.localStorage(
          'columns-visibility',
          columns.map((column) => column.hidden)
        )
      }
    },

    setPaginationLimit(value) {
      this.$emit('pagination-limit-change', value)
      this.localStorage('pagination-limit', value)
    },

    setInitialSearchValue() {
      this.searchValue = getSearchQuery()
    },
  },
}
</script>

<template>
  <div class="my-4 rounded bg-gray-50">
    <div class="flex flex-col items-end justify-end p-3 sm:flex-row">
      <gl-search-box-by-type
        v-model="searchValue"
        class="w-full grow sm:mr-3"
        @input="search"
      />
      <div class="gl-mt-4 flex shrink space-x-3 sm:mt-0">
        <gl-button @click="toggleSettings">
          {{ showSettings ? 'Close' : 'Customize table' }}
        </gl-button>
        <gl-button :href="exportPath" icon="export">Export</gl-button>
        <gl-button v-show="sharePath" icon="share" :href="sharePath">
          Share
        </gl-button>
      </div>
    </div>

    <div v-show="showSettings" class="space-y-5 p-3">
      <div>
        <div class="mb-2 text-sm font-medium text-gray-600">Table fields</div>
        <gl-label
          v-for="column in configurableColumns"
          :key="column.id"
          :background-color="column.hidden ? '#E2E8F0' : '#6366F1'"
          :title="column.plainName || column.name"
          tooltip-placement="top"
          class="mr-2 mb-2 cursor-pointer hover:no-underline"
          :show-close-button="!column.hidden"
          @click="toggleColumn(column.id, true)"
          @close.stop="toggleColumn(column.id)"
        />
      </div>

      <div>
        <div class="mb-2 text-sm font-medium text-gray-600">Pagination</div>
        <div class="flex items-center space-x-2 text-sm">
          <span>Show</span>
          <gl-form-select
            size="sm"
            :options="paginationOptions"
            :value="paginationLimit"
            class="w-auto"
            @change="setPaginationLimit"
          />
          <span>results</span>
        </div>
      </div>
    </div>
  </div>
</template>
